package java.util;

import java.util.function.UnaryOperator;
import java.util.function.Consumer;
import java.io.Serializable;
import java.security.AccessController;
import sun.security.action.GetBooleanAction;
import java.util.stream.DoubleStream;
import java.util.stream.LongStream;
import java.util.stream.StreamSupport;
import java.util.stream.Stream;
import java.util.function.IntToDoubleFunction;
import java.util.function.IntToLongFunction;
import java.util.function.IntUnaryOperator;
import java.util.stream.IntStream;
import java.util.function.IntFunction;
import java.util.function.IntBinaryOperator;
import java.util.function.DoubleBinaryOperator;
import java.util.function.LongBinaryOperator;
import java.util.function.BinaryOperator;
import java.lang.reflect.Array;
import java.util.concurrent.ForkJoinPool;

public class Arrays
{
    private static final int MIN_ARRAY_SORT_GRAN = 8192;
    private static final int INSERTIONSORT_THRESHOLD = 7;
    
    private Arrays() {
    }
    
    private static void rangeCheck(int n, int n2, int n3) {
        if (n2 > n3) {
            throw new IllegalArgumentException("fromIndex(" + n2 + ") > toIndex(" + n3 + ")");
        }
        if (n2 < 0) {
            throw new ArrayIndexOutOfBoundsException(n2);
        }
        if (n3 > n) {
            throw new ArrayIndexOutOfBoundsException(n3);
        }
        return;
    }
    
    public static void sort(int[] array) {
        DualPivotQuicksort.sort(array, 0, array.length - 1, null, 0, 0);
    }
    
    public static void sort(int[] array, int n, int n2) {
        rangeCheck(array.length, n, n2);
        DualPivotQuicksort.sort(array, n, n2 - 1, null, 0, 0);
    }
    
    public static void sort(long[] array) {
        DualPivotQuicksort.sort(array, 0, array.length - 1, null, 0, 0);
    }
    
    public static void sort(long[] array, int n, int n2) {
        rangeCheck(array.length, n, n2);
        DualPivotQuicksort.sort(array, n, n2 - 1, null, 0, 0);
    }
    
    public static void sort(short[] array) {
        DualPivotQuicksort.sort(array, 0, array.length - 1, null, 0, 0);
    }
    
    public static void sort(short[] array, int n, int n2) {
        rangeCheck(array.length, n, n2);
        DualPivotQuicksort.sort(array, n, n2 - 1, null, 0, 0);
    }
    
    public static void sort(char[] array) {
        DualPivotQuicksort.sort(array, 0, array.length - 1, null, 0, 0);
    }
    
    public static void sort(char[] array, int n, int n2) {
        rangeCheck(array.length, n, n2);
        DualPivotQuicksort.sort(array, n, n2 - 1, null, 0, 0);
    }
    
    public static void sort(byte[] array) {
        DualPivotQuicksort.sort(array, 0, array.length - 1);
    }
    
    public static void sort(byte[] array, int n, int n2) {
        rangeCheck(array.length, n, n2);
        DualPivotQuicksort.sort(array, n, n2 - 1);
    }
    
    public static void sort(float[] array) {
        DualPivotQuicksort.sort(array, 0, array.length - 1, null, 0, 0);
    }
    
    public static void sort(float[] array, int n, int n2) {
        rangeCheck(array.length, n, n2);
        DualPivotQuicksort.sort(array, n, n2 - 1, null, 0, 0);
    }
    
    public static void sort(double[] array) {
        DualPivotQuicksort.sort(array, 0, array.length - 1, null, 0, 0);
    }
    
    public static void sort(double[] array, int n, int n2) {
        rangeCheck(array.length, n, n2);
        DualPivotQuicksort.sort(array, n, n2 - 1, null, 0, 0);
    }
    
    public static void parallelSort(byte[] array) {
        int length = array.length;
        int commonPoolParallelism;
        if (length <= 8192 || (commonPoolParallelism = ForkJoinPool.getCommonPoolParallelism()) == 1) {
            DualPivotQuicksort.sort(array, 0, length - 1);
        }
        else {
            int n;
            new ArraysParallelSortHelpers.FJByte.Sorter(null, array, new byte[length], 0, length, 0, ((n = length / (commonPoolParallelism << 2)) <= 8192) ? 8192 : n).invoke();
        }
    }
    
    public static void parallelSort(byte[] array, int n, int n2) {
        rangeCheck(array.length, n, n2);
        int n3 = n2 - n;
        int commonPoolParallelism;
        if (n3 <= 8192 || (commonPoolParallelism = ForkJoinPool.getCommonPoolParallelism()) == 1) {
            DualPivotQuicksort.sort(array, n, n2 - 1);
        }
        else {
            int n4;
            new ArraysParallelSortHelpers.FJByte.Sorter(null, array, new byte[n3], n, n3, 0, ((n4 = n3 / (commonPoolParallelism << 2)) <= 8192) ? 8192 : n4).invoke();
        }
    }
    
    public static void parallelSort(char[] array) {
        int length = array.length;
        int commonPoolParallelism;
        if (length <= 8192 || (commonPoolParallelism = ForkJoinPool.getCommonPoolParallelism()) == 1) {
            DualPivotQuicksort.sort(array, 0, length - 1, null, 0, 0);
        }
        else {
            int n;
            new ArraysParallelSortHelpers.FJChar.Sorter(null, array, new char[length], 0, length, 0, ((n = length / (commonPoolParallelism << 2)) <= 8192) ? 8192 : n).invoke();
        }
    }
    
    public static void parallelSort(char[] array, int n, int n2) {
        rangeCheck(array.length, n, n2);
        int n3 = n2 - n;
        int commonPoolParallelism;
        if (n3 <= 8192 || (commonPoolParallelism = ForkJoinPool.getCommonPoolParallelism()) == 1) {
            DualPivotQuicksort.sort(array, n, n2 - 1, null, 0, 0);
        }
        else {
            int n4;
            new ArraysParallelSortHelpers.FJChar.Sorter(null, array, new char[n3], n, n3, 0, ((n4 = n3 / (commonPoolParallelism << 2)) <= 8192) ? 8192 : n4).invoke();
        }
    }
    
    public static void parallelSort(short[] array) {
        int length = array.length;
        int commonPoolParallelism;
        if (length <= 8192 || (commonPoolParallelism = ForkJoinPool.getCommonPoolParallelism()) == 1) {
            DualPivotQuicksort.sort(array, 0, length - 1, null, 0, 0);
        }
        else {
            int n;
            new ArraysParallelSortHelpers.FJShort.Sorter(null, array, new short[length], 0, length, 0, ((n = length / (commonPoolParallelism << 2)) <= 8192) ? 8192 : n).invoke();
        }
    }
    
    public static void parallelSort(short[] array, int n, int n2) {
        rangeCheck(array.length, n, n2);
        int n3 = n2 - n;
        int commonPoolParallelism;
        if (n3 <= 8192 || (commonPoolParallelism = ForkJoinPool.getCommonPoolParallelism()) == 1) {
            DualPivotQuicksort.sort(array, n, n2 - 1, null, 0, 0);
        }
        else {
            int n4;
            new ArraysParallelSortHelpers.FJShort.Sorter(null, array, new short[n3], n, n3, 0, ((n4 = n3 / (commonPoolParallelism << 2)) <= 8192) ? 8192 : n4).invoke();
        }
    }
    
    public static void parallelSort(int[] array) {
        int length = array.length;
        int commonPoolParallelism;
        if (length <= 8192 || (commonPoolParallelism = ForkJoinPool.getCommonPoolParallelism()) == 1) {
            DualPivotQuicksort.sort(array, 0, length - 1, null, 0, 0);
        }
        else {
            int n;
            new ArraysParallelSortHelpers.FJInt.Sorter(null, array, new int[length], 0, length, 0, ((n = length / (commonPoolParallelism << 2)) <= 8192) ? 8192 : n).invoke();
        }
    }
    
    public static void parallelSort(int[] array, int n, int n2) {
        rangeCheck(array.length, n, n2);
        int n3 = n2 - n;
        int commonPoolParallelism;
        if (n3 <= 8192 || (commonPoolParallelism = ForkJoinPool.getCommonPoolParallelism()) == 1) {
            DualPivotQuicksort.sort(array, n, n2 - 1, null, 0, 0);
        }
        else {
            int n4;
            new ArraysParallelSortHelpers.FJInt.Sorter(null, array, new int[n3], n, n3, 0, ((n4 = n3 / (commonPoolParallelism << 2)) <= 8192) ? 8192 : n4).invoke();
        }
    }
    
    public static void parallelSort(long[] array) {
        int length = array.length;
        int commonPoolParallelism;
        if (length <= 8192 || (commonPoolParallelism = ForkJoinPool.getCommonPoolParallelism()) == 1) {
            DualPivotQuicksort.sort(array, 0, length - 1, null, 0, 0);
        }
        else {
            int n;
            new ArraysParallelSortHelpers.FJLong.Sorter(null, array, new long[length], 0, length, 0, ((n = length / (commonPoolParallelism << 2)) <= 8192) ? 8192 : n).invoke();
        }
    }
    
    public static void parallelSort(long[] array, int n, int n2) {
        rangeCheck(array.length, n, n2);
        int n3 = n2 - n;
        int commonPoolParallelism;
        if (n3 <= 8192 || (commonPoolParallelism = ForkJoinPool.getCommonPoolParallelism()) == 1) {
            DualPivotQuicksort.sort(array, n, n2 - 1, null, 0, 0);
        }
        else {
            int n4;
            new ArraysParallelSortHelpers.FJLong.Sorter(null, array, new long[n3], n, n3, 0, ((n4 = n3 / (commonPoolParallelism << 2)) <= 8192) ? 8192 : n4).invoke();
        }
    }
    
    public static void parallelSort(float[] array) {
        int length = array.length;
        int commonPoolParallelism;
        if (length <= 8192 || (commonPoolParallelism = ForkJoinPool.getCommonPoolParallelism()) == 1) {
            DualPivotQuicksort.sort(array, 0, length - 1, null, 0, 0);
        }
        else {
            int n;
            new ArraysParallelSortHelpers.FJFloat.Sorter(null, array, new float[length], 0, length, 0, ((n = length / (commonPoolParallelism << 2)) <= 8192) ? 8192 : n).invoke();
        }
    }
    
    public static void parallelSort(float[] array, int n, int n2) {
        rangeCheck(array.length, n, n2);
        int n3 = n2 - n;
        int commonPoolParallelism;
        if (n3 <= 8192 || (commonPoolParallelism = ForkJoinPool.getCommonPoolParallelism()) == 1) {
            DualPivotQuicksort.sort(array, n, n2 - 1, null, 0, 0);
        }
        else {
            int n4;
            new ArraysParallelSortHelpers.FJFloat.Sorter(null, array, new float[n3], n, n3, 0, ((n4 = n3 / (commonPoolParallelism << 2)) <= 8192) ? 8192 : n4).invoke();
        }
    }
    
    public static void parallelSort(double[] array) {
        int length = array.length;
        int commonPoolParallelism;
        if (length <= 8192 || (commonPoolParallelism = ForkJoinPool.getCommonPoolParallelism()) == 1) {
            DualPivotQuicksort.sort(array, 0, length - 1, null, 0, 0);
        }
        else {
            int n;
            new ArraysParallelSortHelpers.FJDouble.Sorter(null, array, new double[length], 0, length, 0, ((n = length / (commonPoolParallelism << 2)) <= 8192) ? 8192 : n).invoke();
        }
    }
    
    public static void parallelSort(double[] array, int n, int n2) {
        rangeCheck(array.length, n, n2);
        int n3 = n2 - n;
        int commonPoolParallelism;
        if (n3 <= 8192 || (commonPoolParallelism = ForkJoinPool.getCommonPoolParallelism()) == 1) {
            DualPivotQuicksort.sort(array, n, n2 - 1, null, 0, 0);
        }
        else {
            int n4;
            new ArraysParallelSortHelpers.FJDouble.Sorter(null, array, new double[n3], n, n3, 0, ((n4 = n3 / (commonPoolParallelism << 2)) <= 8192) ? 8192 : n4).invoke();
        }
    }
    
    public static <T extends Comparable<? super T>> void parallelSort(T[] array) {
        int length = array.length;
        int commonPoolParallelism;
        if (length <= 8192 || (commonPoolParallelism = ForkJoinPool.getCommonPoolParallelism()) == 1) {
            TimSort.sort(array, 0, length, Arrays.NaturalOrder.INSTANCE, null, 0, 0);
        }
        else {
            int n;
            new ArraysParallelSortHelpers.FJObject.Sorter(null, array, (Comparable[])(Comparable[])Array.newInstance(array.getClass().getComponentType(), length), 0, length, 0, ((n = length / (commonPoolParallelism << 2)) <= 8192) ? 8192 : n, Arrays.NaturalOrder.INSTANCE).invoke();
        }
    }
    
    public static <T extends Comparable<? super T>> void parallelSort(T[] array, int n, int n2) {
        rangeCheck(array.length, n, n2);
        int length = n2 - n;
        int commonPoolParallelism;
        if (length <= 8192 || (commonPoolParallelism = ForkJoinPool.getCommonPoolParallelism()) == 1) {
            TimSort.sort(array, n, n2, Arrays.NaturalOrder.INSTANCE, null, 0, 0);
        }
        else {
            int n3;
            new ArraysParallelSortHelpers.FJObject.Sorter(null, array, (Comparable[])(Comparable[])Array.newInstance(array.getClass().getComponentType(), length), n, length, 0, ((n3 = length / (commonPoolParallelism << 2)) <= 8192) ? 8192 : n3, Arrays.NaturalOrder.INSTANCE).invoke();
        }
    }
    
    public static <T> void parallelSort(T[] array, Comparator<? super T> instance) {
        if (instance == null) {
            instance = Arrays.NaturalOrder.INSTANCE;
        }
        int length = array.length;
        int commonPoolParallelism;
        if (length <= 8192 || (commonPoolParallelism = ForkJoinPool.getCommonPoolParallelism()) == 1) {
            TimSort.sort(array, 0, length, instance, null, 0, 0);
        }
        else {
            int n;
            new ArraysParallelSortHelpers.FJObject.Sorter(null, array, (Object[])(Object[])Array.newInstance(array.getClass().getComponentType(), length), 0, length, 0, ((n = length / (commonPoolParallelism << 2)) <= 8192) ? 8192 : n, instance).invoke();
        }
    }
    
    public static <T> void parallelSort(T[] array, int n, int n2, Comparator<? super T> instance) {
        rangeCheck(array.length, n, n2);
        if (instance == null) {
            instance = Arrays.NaturalOrder.INSTANCE;
        }
        int length = n2 - n;
        int commonPoolParallelism;
        if (length <= 8192 || (commonPoolParallelism = ForkJoinPool.getCommonPoolParallelism()) == 1) {
            TimSort.sort(array, n, n2, instance, null, 0, 0);
        }
        else {
            int n3;
            new ArraysParallelSortHelpers.FJObject.Sorter(null, array, (Object[])(Object[])Array.newInstance(array.getClass().getComponentType(), length), n, length, 0, ((n3 = length / (commonPoolParallelism << 2)) <= 8192) ? 8192 : n3, instance).invoke();
        }
    }
    
    public static void sort(Object[] array) {
        if (Arrays.LegacyMergeSort.userRequested) {
            legacyMergeSort(array);
        }
        else {
            ComparableTimSort.sort(array, 0, array.length, null, 0, 0);
        }
    }
    
    private static void legacyMergeSort(Object[] array) {
        mergeSort((Object[])array.clone(), array, 0, array.length, 0);
    }
    
    public static void sort(Object[] array, int n, int n2) {
        rangeCheck(array.length, n, n2);
        if (Arrays.LegacyMergeSort.userRequested) {
            legacyMergeSort(array, n, n2);
        }
        else {
            ComparableTimSort.sort(array, n, n2, null, 0, 0);
        }
    }
    
    private static void legacyMergeSort(Object[] array, int n, int n2) {
        mergeSort(copyOfRange(array, n, n2), array, n, n2, -n);
    }
    
    private static void mergeSort(Object[] array, Object[] array2, int i, int n, int n2) {
        int n3 = n - i;
        if (n3 < 7) {
            for (; i < n; ++i) {
                for (; i > i && ((Comparable)array2[i - 1]).compareTo(array2[i]) > 0; --i) {
                    swap(array2, i, i - 1);
                }
            }
            return;
        }
        i += n2;
        n += n2;
        int n4 = i + n >>> 1;
        mergeSort(array2, array, i, n4, -n2);
        mergeSort(array2, array, n4, n, -n2);
        if (((Comparable)array[n4 - 1]).compareTo(array[n4]) <= 0) {
            System.arraycopy(array, i, array2, i, n3);
            return;
        }
        i = (i = i);
        while (i < n) {
            if (n4 >= n || (i < n4 && ((Comparable)array[i]).compareTo(array[n4]) <= 0)) {
                array2[i] = array[i++];
            }
            else {
                array2[i] = array[n4++];
            }
            ++i;
        }
        return;
    }
    
    private static void swap(Object[] array, int n, int n2) {
        Object o = array[n];
        array[n] = array[n2];
        array[n2] = o;
    }
    
    public static <T> void sort(T[] array, Comparator<? super T> comparator) {
        if (comparator == null) {
            sort(array);
        }
        else if (Arrays.LegacyMergeSort.userRequested) {
            legacyMergeSort(array, comparator);
        }
        else {
            TimSort.sort(array, 0, array.length, comparator, null, 0, 0);
        }
    }
    
    private static <T> void legacyMergeSort(T[] array, Comparator<? super T> comparator) {
        Object[] array2 = (T[])array.clone();
        if (comparator == null) {
            mergeSort(array2, array, 0, array.length, 0);
        }
        else {
            mergeSort(array2, array, 0, array.length, 0, comparator);
        }
    }
    
    public static <T> void sort(T[] array, int n, int n2, Comparator<? super T> comparator) {
        if (comparator == null) {
            sort(array, n, n2);
        }
        else {
            rangeCheck(array.length, n, n2);
            if (Arrays.LegacyMergeSort.userRequested) {
                legacyMergeSort(array, n, n2, comparator);
            }
            else {
                TimSort.sort(array, n, n2, comparator, null, 0, 0);
            }
        }
    }
    
    private static <T> void legacyMergeSort(T[] array, int n, int n2, Comparator<? super T> comparator) {
        Object[] copyOfRange = copyOfRange(array, n, n2);
        if (comparator == null) {
            mergeSort(copyOfRange, array, n, n2, -n);
        }
        else {
            mergeSort(copyOfRange, array, n, n2, -n, comparator);
        }
    }
    
    private static void mergeSort(Object[] array, Object[] array2, int i, int n, int n2, Comparator comparator) {
        int n3 = n - i;
        if (n3 < 7) {
            for (; i < n; ++i) {
                for (; i > i && comparator.compare(array2[i - 1], array2[i]) > 0; --i) {
                    swap(array2, i, i - 1);
                }
            }
            return;
        }
        i += n2;
        n += n2;
        int n4 = i + n >>> 1;
        mergeSort(array2, array, i, n4, -n2, comparator);
        mergeSort(array2, array, n4, n, -n2, comparator);
        if (comparator.compare(array[n4 - 1], array[n4]) <= 0) {
            System.arraycopy(array, i, array2, i, n3);
            return;
        }
        i = (i = i);
        while (i < n) {
            if (n4 >= n || (i < n4 && comparator.compare(array[i], array[n4]) <= 0)) {
                array2[i] = array[i++];
            }
            else {
                array2[i] = array[n4++];
            }
            ++i;
        }
        return;
    }
    
    public static <T> void parallelPrefix(T[] array, BinaryOperator<T> binaryOperator) {
        Objects.requireNonNull(binaryOperator);
        if (array.length > 0) {
            new ArrayPrefixHelpers.CumulateTask(null, binaryOperator, array, 0, array.length).invoke();
        }
    }
    
    public static <T> void parallelPrefix(T[] array, int n, int n2, BinaryOperator<T> binaryOperator) {
        Objects.requireNonNull(binaryOperator);
        rangeCheck(array.length, n, n2);
        if (n < n2) {
            new ArrayPrefixHelpers.CumulateTask(null, binaryOperator, array, n, n2).invoke();
        }
    }
    
    public static void parallelPrefix(long[] array, LongBinaryOperator longBinaryOperator) {
        Objects.requireNonNull(longBinaryOperator);
        if (array.length > 0) {
            new ArrayPrefixHelpers.LongCumulateTask(null, longBinaryOperator, array, 0, array.length).invoke();
        }
    }
    
    public static void parallelPrefix(long[] array, int n, int n2, LongBinaryOperator longBinaryOperator) {
        Objects.requireNonNull(longBinaryOperator);
        rangeCheck(array.length, n, n2);
        if (n < n2) {
            new ArrayPrefixHelpers.LongCumulateTask(null, longBinaryOperator, array, n, n2).invoke();
        }
    }
    
    public static void parallelPrefix(double[] array, DoubleBinaryOperator doubleBinaryOperator) {
        Objects.requireNonNull(doubleBinaryOperator);
        if (array.length > 0) {
            new ArrayPrefixHelpers.DoubleCumulateTask(null, doubleBinaryOperator, array, 0, array.length).invoke();
        }
    }
    
    public static void parallelPrefix(double[] array, int n, int n2, DoubleBinaryOperator doubleBinaryOperator) {
        Objects.requireNonNull(doubleBinaryOperator);
        rangeCheck(array.length, n, n2);
        if (n < n2) {
            new ArrayPrefixHelpers.DoubleCumulateTask(null, doubleBinaryOperator, array, n, n2).invoke();
        }
    }
    
    public static void parallelPrefix(int[] array, IntBinaryOperator intBinaryOperator) {
        Objects.requireNonNull(intBinaryOperator);
        if (array.length > 0) {
            new ArrayPrefixHelpers.IntCumulateTask(null, intBinaryOperator, array, 0, array.length).invoke();
        }
    }
    
    public static void parallelPrefix(int[] array, int n, int n2, IntBinaryOperator intBinaryOperator) {
        Objects.requireNonNull(intBinaryOperator);
        rangeCheck(array.length, n, n2);
        if (n < n2) {
            new ArrayPrefixHelpers.IntCumulateTask(null, intBinaryOperator, array, n, n2).invoke();
        }
    }
    
    public static int binarySearch(long[] array, long n) {
        return binarySearch0(array, 0, array.length, n);
    }
    
    public static int binarySearch(long[] array, int n, int n2, long n3) {
        rangeCheck(array.length, n, n2);
        return binarySearch0(array, n, n2, n3);
    }
    
    private static int binarySearch0(long[] array, int i, int n, long n2) {
        int n3 = n - 1;
        while (i <= n3) {
            int n4 = i + n3 >>> 1;
            long n5 = array[n4];
            if (n5 < n2) {
                i = n4 + 1;
            }
            else if (n5 > n2) {
                n3 = n4 - 1;
            }
            else {
                return n4;
            }
        }
        return -(i + 1);
    }
    
    public static int binarySearch(int[] array, int n) {
        return binarySearch0(array, 0, array.length, n);
    }
    
    public static int binarySearch(int[] array, int n, int n2, int n3) {
        rangeCheck(array.length, n, n2);
        return binarySearch0(array, n, n2, n3);
    }
    
    private static int binarySearch0(int[] array, int i, int n, int n2) {
        int n3 = n - 1;
        while (i <= n3) {
            int n4 = i + n3 >>> 1;
            int n5 = array[n4];
            if (n5 < n2) {
                i = n4 + 1;
            }
            else if (n5 > n2) {
                n3 = n4 - 1;
            }
            else {
                return n4;
            }
        }
        return -(i + 1);
    }
    
    public static int binarySearch(short[] array, short n) {
        return binarySearch0(array, 0, array.length, n);
    }
    
    public static int binarySearch(short[] array, int n, int n2, short n3) {
        rangeCheck(array.length, n, n2);
        return binarySearch0(array, n, n2, n3);
    }
    
    private static int binarySearch0(short[] array, int i, int n, short n2) {
        int n3 = n - 1;
        while (i <= n3) {
            int n4 = i + n3 >>> 1;
            int n5 = array[n4];
            if (n5 < n2) {
                i = n4 + 1;
            }
            else if (n5 > n2) {
                n3 = n4 - 1;
            }
            else {
                return n4;
            }
        }
        return -(i + 1);
    }
    
    public static int binarySearch(char[] array, char c) {
        return binarySearch0(array, 0, array.length, c);
    }
    
    public static int binarySearch(char[] array, int n, int n2, char c) {
        rangeCheck(array.length, n, n2);
        return binarySearch0(array, n, n2, c);
    }
    
    private static int binarySearch0(char[] array, int i, int n, char c) {
        int n2 = n - 1;
        while (i <= n2) {
            int n3 = i + n2 >>> 1;
            int n4 = array[n3];
            if (n4 < c) {
                i = n3 + 1;
            }
            else if (n4 > c) {
                n2 = n3 - 1;
            }
            else {
                return n3;
            }
        }
        return -(i + 1);
    }
    
    public static int binarySearch(byte[] array, byte b) {
        return binarySearch0(array, 0, array.length, b);
    }
    
    public static int binarySearch(byte[] array, int n, int n2, byte b) {
        rangeCheck(array.length, n, n2);
        return binarySearch0(array, n, n2, b);
    }
    
    private static int binarySearch0(byte[] array, int i, int n, byte b) {
        int n2 = n - 1;
        while (i <= n2) {
            int n3 = i + n2 >>> 1;
            int n4 = array[n3];
            if (n4 < b) {
                i = n3 + 1;
            }
            else if (n4 > b) {
                n2 = n3 - 1;
            }
            else {
                return n3;
            }
        }
        return -(i + 1);
    }
    
    public static int binarySearch(double[] array, double n) {
        return binarySearch0(array, 0, array.length, n);
    }
    
    public static int binarySearch(double[] array, int n, int n2, double n3) {
        rangeCheck(array.length, n, n2);
        return binarySearch0(array, n, n2, n3);
    }
    
    private static int binarySearch0(double[] array, int i, int n, double value) {
        int n2 = n - 1;
        while (i <= n2) {
            int n3 = i + n2 >>> 1;
            double value2 = array[n3];
            if (value2 < value) {
                i = n3 + 1;
            }
            else if (value2 > value) {
                n2 = n3 - 1;
            }
            else {
                long doubleToLongBits = Double.doubleToLongBits(value2);
                long doubleToLongBits2 = Double.doubleToLongBits(value);
                if (doubleToLongBits == doubleToLongBits2) {
                    return n3;
                }
                if (doubleToLongBits < doubleToLongBits2) {
                    i = n3 + 1;
                }
                else {
                    n2 = n3 - 1;
                }
            }
        }
        return -(i + 1);
    }
    
    public static int binarySearch(float[] array, float n) {
        return binarySearch0(array, 0, array.length, n);
    }
    
    public static int binarySearch(float[] array, int n, int n2, float n3) {
        rangeCheck(array.length, n, n2);
        return binarySearch0(array, n, n2, n3);
    }
    
    private static int binarySearch0(float[] array, int i, int n, float value) {
        int n2 = n - 1;
        while (i <= n2) {
            int n3 = i + n2 >>> 1;
            float value2 = array[n3];
            if (value2 < value) {
                i = n3 + 1;
            }
            else if (value2 > value) {
                n2 = n3 - 1;
            }
            else {
                int floatToIntBits = Float.floatToIntBits(value2);
                int floatToIntBits2 = Float.floatToIntBits(value);
                if (floatToIntBits == floatToIntBits2) {
                    return n3;
                }
                if (floatToIntBits < floatToIntBits2) {
                    i = n3 + 1;
                }
                else {
                    n2 = n3 - 1;
                }
            }
        }
        return -(i + 1);
    }
    
    public static int binarySearch(Object[] array, Object o) {
        return binarySearch0(array, 0, array.length, o);
    }
    
    public static int binarySearch(Object[] array, int n, int n2, Object o) {
        rangeCheck(array.length, n, n2);
        return binarySearch0(array, n, n2, o);
    }
    
    private static int binarySearch0(Object[] array, int i, int n, Object o) {
        int n2 = n - 1;
        while (i <= n2) {
            int n3 = i + n2 >>> 1;
            int compareTo = ((Comparable)array[n3]).compareTo(o);
            if (compareTo < 0) {
                i = n3 + 1;
            }
            else if (compareTo > 0) {
                n2 = n3 - 1;
            }
            else {
                return n3;
            }
        }
        return -(i + 1);
    }
    
    public static <T> int binarySearch(T[] array, T t, Comparator<? super T> comparator) {
        return binarySearch0(array, 0, array.length, t, comparator);
    }
    
    public static <T> int binarySearch(T[] array, int n, int n2, T t, Comparator<? super T> comparator) {
        rangeCheck(array.length, n, n2);
        return binarySearch0(array, n, n2, t, comparator);
    }
    
    private static <T> int binarySearch0(T[] array, int i, int n, T t, Comparator<? super T> comparator) {
        if (comparator == null) {
            return binarySearch0(array, i, n, t);
        }
        int n2 = n - 1;
        while (i <= n2) {
            int n3 = i + n2 >>> 1;
            int compare = comparator.compare(array[n3], t);
            if (compare < 0) {
                i = n3 + 1;
            }
            else if (compare > 0) {
                n2 = n3 - 1;
            }
            else {
                return n3;
            }
        }
        return -(i + 1);
    }
    
    public static boolean equals(long[] array, long[] array2) {
        if (array == array2) {
            return true;
        }
        if (array == null || array2 == null) {
            return false;
        }
        int length = array.length;
        if (array2.length != length) {
            return false;
        }
        int i = 0;
        while (i < length) {
            if (array[i] != array2[i]) {
                return false;
            }
            ++i;
        }
        return true;
    }
    
    public static boolean equals(int[] array, int[] array2) {
        if (array == array2) {
            return true;
        }
        if (array == null || array2 == null) {
            return false;
        }
        int length = array.length;
        if (array2.length != length) {
            return false;
        }
        int i = 0;
        while (i < length) {
            if (array[i] != array2[i]) {
                return false;
            }
            ++i;
        }
        return true;
    }
    
    public static boolean equals(short[] array, short[] array2) {
        if (array == array2) {
            return true;
        }
        if (array == null || array2 == null) {
            return false;
        }
        int length = array.length;
        if (array2.length != length) {
            return false;
        }
        int i = 0;
        while (i < length) {
            if (array[i] != array2[i]) {
                return false;
            }
            ++i;
        }
        return true;
    }
    
    public static boolean equals(char[] array, char[] array2) {
        if (array == array2) {
            return true;
        }
        if (array == null || array2 == null) {
            return false;
        }
        int length = array.length;
        if (array2.length != length) {
            return false;
        }
        int i = 0;
        while (i < length) {
            if (array[i] != array2[i]) {
                return false;
            }
            ++i;
        }
        return true;
    }
    
    public static boolean equals(byte[] array, byte[] array2) {
        if (array == array2) {
            return true;
        }
        if (array == null || array2 == null) {
            return false;
        }
        int length = array.length;
        if (array2.length != length) {
            return false;
        }
        int i = 0;
        while (i < length) {
            if (array[i] != array2[i]) {
                return false;
            }
            ++i;
        }
        return true;
    }
    
    public static boolean equals(boolean[] array, boolean[] array2) {
        if (array == array2) {
            return true;
        }
        if (array == null || array2 == null) {
            return false;
        }
        int length = array.length;
        if (array2.length != length) {
            return false;
        }
        int i = 0;
        while (i < length) {
            if (array[i] != array2[i]) {
                return false;
            }
            ++i;
        }
        return true;
    }
    
    public static boolean equals(double[] array, double[] array2) {
        if (array == array2) {
            return true;
        }
        if (array == null || array2 == null) {
            return false;
        }
        int length = array.length;
        if (array2.length != length) {
            return false;
        }
        int i = 0;
        while (i < length) {
            if (Double.doubleToLongBits(array[i]) != Double.doubleToLongBits(array2[i])) {
                return false;
            }
            ++i;
        }
        return true;
    }
    
    public static boolean equals(float[] array, float[] array2) {
        if (array == array2) {
            return true;
        }
        if (array == null || array2 == null) {
            return false;
        }
        int length = array.length;
        if (array2.length != length) {
            return false;
        }
        int i = 0;
        while (i < length) {
            if (Float.floatToIntBits(array[i]) != Float.floatToIntBits(array2[i])) {
                return false;
            }
            ++i;
        }
        return true;
    }
    
    public static boolean equals(Object[] array, Object[] array2) {
        if (array == array2) {
            return true;
        }
        if (array == null || array2 == null) {
            return false;
        }
        int length = array.length;
        if (array2.length != length) {
            return false;
        }
        int i = 0;
        while (i < length) {
            Object o = array[i];
            Object obj = array2[i];
            if ((o != null) ? o.equals(obj) : (obj == null)) {
                ++i;
                continue;
            }
            return false;
        }
        return true;
    }
    
    public static void fill(long[] array, long n) {
        for (int i = 0; i < array.length; ++i) {
            array[i] = n;
        }
    }
    
    public static void fill(long[] array, int i, int n, long n2) {
        rangeCheck(array.length, i, n);
        for (; i < n; ++i) {
            array[i] = n2;
        }
    }
    
    public static void fill(int[] array, int n) {
        for (int i = 0; i < array.length; ++i) {
            array[i] = n;
        }
    }
    
    public static void fill(int[] array, int i, int n, int n2) {
        rangeCheck(array.length, i, n);
        for (; i < n; ++i) {
            array[i] = n2;
        }
    }
    
    public static void fill(short[] array, short n) {
        for (int i = 0; i < array.length; ++i) {
            array[i] = n;
        }
    }
    
    public static void fill(short[] array, int i, int n, short n2) {
        rangeCheck(array.length, i, n);
        for (; i < n; ++i) {
            array[i] = n2;
        }
    }
    
    public static void fill(char[] array, char c) {
        for (int i = 0; i < array.length; ++i) {
            array[i] = c;
        }
    }
    
    public static void fill(char[] array, int i, int n, char c) {
        rangeCheck(array.length, i, n);
        for (; i < n; ++i) {
            array[i] = c;
        }
    }
    
    public static void fill(byte[] array, byte b) {
        for (int i = 0; i < array.length; ++i) {
            array[i] = b;
        }
    }
    
    public static void fill(byte[] array, int i, int n, byte b) {
        rangeCheck(array.length, i, n);
        for (; i < n; ++i) {
            array[i] = b;
        }
    }
    
    public static void fill(boolean[] array, boolean b) {
        for (int i = 0; i < array.length; ++i) {
            array[i] = b;
        }
    }
    
    public static void fill(boolean[] array, int i, int n, boolean b) {
        rangeCheck(array.length, i, n);
        for (; i < n; ++i) {
            array[i] = b;
        }
    }
    
    public static void fill(double[] array, double n) {
        for (int i = 0; i < array.length; ++i) {
            array[i] = n;
        }
    }
    
    public static void fill(double[] array, int i, int n, double n2) {
        rangeCheck(array.length, i, n);
        for (; i < n; ++i) {
            array[i] = n2;
        }
    }
    
    public static void fill(float[] array, float n) {
        for (int i = 0; i < array.length; ++i) {
            array[i] = n;
        }
    }
    
    public static void fill(float[] array, int i, int n, float n2) {
        rangeCheck(array.length, i, n);
        for (; i < n; ++i) {
            array[i] = n2;
        }
    }
    
    public static void fill(Object[] array, Object o) {
        for (int i = 0; i < array.length; ++i) {
            array[i] = o;
        }
    }
    
    public static void fill(Object[] array, int i, int n, Object o) {
        rangeCheck(array.length, i, n);
        for (; i < n; ++i) {
            array[i] = o;
        }
    }
    
    public static <T> T[] copyOf(T[] array, int n) {
        return (T[])copyOf(array, n, array.getClass());
    }
    
    public static <T, U> T[] copyOf(U[] array, int n, Class<? extends T[]> clazz) {
        Object[] array2 = (clazz == Object[].class) ? ((Object[])new Object[n]) : ((Object[])(Object[])Array.newInstance(clazz.getComponentType(), n));
        System.arraycopy(array, 0, array2, 0, Math.min(array.length, n));
        return array2;
    }
    
    public static byte[] copyOf(byte[] array, int b) {
        byte[] array2 = new byte[b];
        System.arraycopy(array, 0, array2, 0, Math.min(array.length, b));
        return array2;
    }
    
    public static short[] copyOf(short[] array, int b) {
        short[] array2 = new short[b];
        System.arraycopy(array, 0, array2, 0, Math.min(array.length, b));
        return array2;
    }
    
    public static int[] copyOf(int[] array, int b) {
        int[] array2 = new int[b];
        System.arraycopy(array, 0, array2, 0, Math.min(array.length, b));
        return array2;
    }
    
    public static long[] copyOf(long[] array, int b) {
        long[] array2 = new long[b];
        System.arraycopy(array, 0, array2, 0, Math.min(array.length, b));
        return array2;
    }
    
    public static char[] copyOf(char[] array, int b) {
        char[] array2 = new char[b];
        System.arraycopy(array, 0, array2, 0, Math.min(array.length, b));
        return array2;
    }
    
    public static float[] copyOf(float[] array, int b) {
        float[] array2 = new float[b];
        System.arraycopy(array, 0, array2, 0, Math.min(array.length, b));
        return array2;
    }
    
    public static double[] copyOf(double[] array, int b) {
        double[] array2 = new double[b];
        System.arraycopy(array, 0, array2, 0, Math.min(array.length, b));
        return array2;
    }
    
    public static boolean[] copyOf(boolean[] array, int b) {
        boolean[] array2 = new boolean[b];
        System.arraycopy(array, 0, array2, 0, Math.min(array.length, b));
        return array2;
    }
    
    public static <T> T[] copyOfRange(T[] array, int n, int n2) {
        return copyOfRange(array, n, n2, array.getClass());
    }
    
    public static <T, U> T[] copyOfRange(U[] array, int i, int j, Class<? extends T[]> clazz) {
        int n = j - i;
        if (n < 0) {
            throw new IllegalArgumentException(i + " > " + j);
        }
        Object[] array2 = (clazz == Object[].class) ? ((Object[])new Object[n]) : ((Object[])(Object[])Array.newInstance(clazz.getComponentType(), n));
        System.arraycopy(array, i, array2, 0, Math.min(array.length - i, n));
        return array2;
    }
    
    public static byte[] copyOfRange(byte[] array, int i, int j) {
        int b = j - i;
        if (b < 0) {
            throw new IllegalArgumentException(i + " > " + j);
        }
        byte[] array2 = new byte[b];
        System.arraycopy(array, i, array2, 0, Math.min(array.length - i, b));
        return array2;
    }
    
    public static short[] copyOfRange(short[] array, int i, int j) {
        int b = j - i;
        if (b < 0) {
            throw new IllegalArgumentException(i + " > " + j);
        }
        short[] array2 = new short[b];
        System.arraycopy(array, i, array2, 0, Math.min(array.length - i, b));
        return array2;
    }
    
    public static int[] copyOfRange(int[] array, int i, int j) {
        int b = j - i;
        if (b < 0) {
            throw new IllegalArgumentException(i + " > " + j);
        }
        int[] array2 = new int[b];
        System.arraycopy(array, i, array2, 0, Math.min(array.length - i, b));
        return array2;
    }
    
    public static long[] copyOfRange(long[] array, int i, int j) {
        int b = j - i;
        if (b < 0) {
            throw new IllegalArgumentException(i + " > " + j);
        }
        long[] array2 = new long[b];
        System.arraycopy(array, i, array2, 0, Math.min(array.length - i, b));
        return array2;
    }
    
    public static char[] copyOfRange(char[] array, int i, int j) {
        int b = j - i;
        if (b < 0) {
            throw new IllegalArgumentException(i + " > " + j);
        }
        char[] array2 = new char[b];
        System.arraycopy(array, i, array2, 0, Math.min(array.length - i, b));
        return array2;
    }
    
    public static float[] copyOfRange(float[] array, int i, int j) {
        int b = j - i;
        if (b < 0) {
            throw new IllegalArgumentException(i + " > " + j);
        }
        float[] array2 = new float[b];
        System.arraycopy(array, i, array2, 0, Math.min(array.length - i, b));
        return array2;
    }
    
    public static double[] copyOfRange(double[] array, int i, int j) {
        int b = j - i;
        if (b < 0) {
            throw new IllegalArgumentException(i + " > " + j);
        }
        double[] array2 = new double[b];
        System.arraycopy(array, i, array2, 0, Math.min(array.length - i, b));
        return array2;
    }
    
    public static boolean[] copyOfRange(boolean[] array, int i, int j) {
        int b = j - i;
        if (b < 0) {
            throw new IllegalArgumentException(i + " > " + j);
        }
        boolean[] array2 = new boolean[b];
        System.arraycopy(array, i, array2, 0, Math.min(array.length - i, b));
        return array2;
    }
    
    @SafeVarargs
    public static <T> List<T> asList(T... array) {
        return new Arrays.ArrayList(array);
    }
    
    public static int hashCode(long[] array) {
        if (array == null) {
            return 0;
        }
        int n = 1;
        for (long n2 : array) {
            n = 31 * n + (int)(n2 ^ n2 >>> 32);
        }
        return n;
    }
    
    public static int hashCode(int[] array) {
        if (array == null) {
            return 0;
        }
        int n = 1;
        for (int length = array.length, i = 0; i < length; ++i) {
            n = 31 * n + array[i];
        }
        return n;
    }
    
    public static int hashCode(short[] array) {
        if (array == null) {
            return 0;
        }
        int n = 1;
        for (int length = array.length, i = 0; i < length; ++i) {
            n = 31 * n + array[i];
        }
        return n;
    }
    
    public static int hashCode(char[] array) {
        if (array == null) {
            return 0;
        }
        int n = 1;
        for (int length = array.length, i = 0; i < length; ++i) {
            n = 31 * n + array[i];
        }
        return n;
    }
    
    public static int hashCode(byte[] array) {
        if (array == null) {
            return 0;
        }
        int n = 1;
        for (int length = array.length, i = 0; i < length; ++i) {
            n = 31 * n + array[i];
        }
        return n;
    }
    
    public static int hashCode(boolean[] array) {
        if (array == null) {
            return 0;
        }
        int n = 1;
        for (int length = array.length, i = 0; i < length; ++i) {
            n = 31 * n + (array[i] ? 1231 : 1237);
        }
        return n;
    }
    
    public static int hashCode(float[] array) {
        if (array == null) {
            return 0;
        }
        int n = 1;
        for (int length = array.length, i = 0; i < length; ++i) {
            n = 31 * n + Float.floatToIntBits(array[i]);
        }
        return n;
    }
    
    public static int hashCode(double[] array) {
        if (array == null) {
            return 0;
        }
        int n = 1;
        for (int length = array.length, i = 0; i < length; ++i) {
            long doubleToLongBits = Double.doubleToLongBits(array[i]);
            n = 31 * n + (int)(doubleToLongBits ^ doubleToLongBits >>> 32);
        }
        return n;
    }
    
    public static int hashCode(Object[] array) {
        if (array == null) {
            return 0;
        }
        int n = 1;
        for (Object o : array) {
            n = 31 * n + ((o == null) ? 0 : o.hashCode());
        }
        return n;
    }
    
    public static int deepHashCode(Object[] array) {
        if (array == null) {
            return 0;
        }
        int n = 1;
        int n2;
        for (int length = array.length, i = 0; i < length; n = 31 * n + n2, ++i) {
            Object o = array[i];
            n2 = 0;
            if ((o instanceof Object[])) {
                n2 = deepHashCode((Object[])(Object[])o);
            }
            else if ((o instanceof byte[])) {
                n2 = hashCode((byte[])(byte[])o);
            }
            else if ((o instanceof short[])) {
                n2 = hashCode((short[])(short[])o);
            }
            else if ((o instanceof int[])) {
                n2 = hashCode((int[])(int[])o);
            }
            else if ((o instanceof long[])) {
                n2 = hashCode((long[])(long[])o);
            }
            else if ((o instanceof char[])) {
                n2 = hashCode((char[])(char[])o);
            }
            else if ((o instanceof float[])) {
                n2 = hashCode((float[])(float[])o);
            }
            else if ((o instanceof double[])) {
                n2 = hashCode((double[])(double[])o);
            }
            else if ((o instanceof boolean[])) {
                n2 = hashCode((boolean[])(boolean[])o);
            }
            else if (o != null) {
                n2 = o.hashCode();
            }
        }
        return n;
    }
    
    public static boolean deepEquals(Object[] array, Object[] array2) {
        if (array == array2) {
            return true;
        }
        if (array == null || array2 == null) {
            return false;
        }
        int length = array.length;
        if (array2.length != length) {
            return false;
        }
        for (int i = 0; i < length; ++i) {
            Object o = array[i];
            Object o2 = array2[i];
            if (o != o2) {
                if (o == null) {
                    return false;
                }
                if (!deepEquals0(o, o2)) {
                    return false;
                }
            }
        }
        return true;
    }
    
    static boolean deepEquals0(Object o, Object obj) {
        assert o != null;
        int n;
        if (o instanceof Object[] && obj instanceof Object[]) {
            n = deepEquals((Object[])(Object[])o, (Object[])(Object[])obj);
        }
        else if (o instanceof byte[] && obj instanceof byte[]) {
            n = equals((byte[])(byte[])o, (byte[])(byte[])obj);
        }
        else if (o instanceof short[] && obj instanceof short[]) {
            n = equals((short[])(short[])o, (short[])(short[])obj);
        }
        else if (o instanceof int[] && obj instanceof int[]) {
            n = equals((int[])(int[])o, (int[])(int[])obj);
        }
        else if (o instanceof long[] && obj instanceof long[]) {
            n = equals((long[])(long[])o, (long[])(long[])obj);
        }
        else if (o instanceof char[] && obj instanceof char[]) {
            n = equals((char[])(char[])o, (char[])(char[])obj);
        }
        else if (o instanceof float[] && obj instanceof float[]) {
            n = equals((float[])(float[])o, (float[])(float[])obj);
        }
        else if (o instanceof double[] && obj instanceof double[]) {
            n = equals((double[])(double[])o, (double[])(double[])obj);
        }
        else if (o instanceof boolean[] && obj instanceof boolean[]) {
            n = equals((boolean[])(boolean[])o, (boolean[])(boolean[])obj);
        }
        else {
            n = o.equals(obj);
        }
        return n;
    }
    
    public static String toString(long[] array) {
        if (array == null) {
            return "null";
        }
        int n = array.length - 1;
        if (n == -1) {
            return "[]";
        }
        StringBuilder sb = new StringBuilder();
        sb.append('[');
        int n2 = 0;
        while (true) {
            sb.append(array[n2]);
            if (n2 == n) {
                break;
            }
            sb.append(", ");
            ++n2;
        }
        return sb.append(']').toString();
    }
    
    public static String toString(int[] array) {
        if (array == null) {
            return "null";
        }
        int n = array.length - 1;
        if (n == -1) {
            return "[]";
        }
        StringBuilder sb = new StringBuilder();
        sb.append('[');
        int n2 = 0;
        while (true) {
            sb.append(array[n2]);
            if (n2 == n) {
                break;
            }
            sb.append(", ");
            ++n2;
        }
        return sb.append(']').toString();
    }
    
    public static String toString(short[] array) {
        if (array == null) {
            return "null";
        }
        int n = array.length - 1;
        if (n == -1) {
            return "[]";
        }
        StringBuilder sb = new StringBuilder();
        sb.append('[');
        int n2 = 0;
        while (true) {
            sb.append((int)array[n2]);
            if (n2 == n) {
                break;
            }
            sb.append(", ");
            ++n2;
        }
        return sb.append(']').toString();
    }
    
    public static String toString(char[] array) {
        if (array == null) {
            return "null";
        }
        int n = array.length - 1;
        if (n == -1) {
            return "[]";
        }
        StringBuilder sb = new StringBuilder();
        sb.append('[');
        int n2 = 0;
        while (true) {
            sb.append(array[n2]);
            if (n2 == n) {
                break;
            }
            sb.append(", ");
            ++n2;
        }
        return sb.append(']').toString();
    }
    
    public static String toString(byte[] array) {
        if (array == null) {
            return "null";
        }
        int n = array.length - 1;
        if (n == -1) {
            return "[]";
        }
        StringBuilder sb = new StringBuilder();
        sb.append('[');
        int n2 = 0;
        while (true) {
            sb.append((int)array[n2]);
            if (n2 == n) {
                break;
            }
            sb.append(", ");
            ++n2;
        }
        return sb.append(']').toString();
    }
    
    public static String toString(boolean[] array) {
        if (array == null) {
            return "null";
        }
        int n = array.length - 1;
        if (n == -1) {
            return "[]";
        }
        StringBuilder sb = new StringBuilder();
        sb.append('[');
        int n2 = 0;
        while (true) {
            sb.append(array[n2]);
            if (n2 == n) {
                break;
            }
            sb.append(", ");
            ++n2;
        }
        return sb.append(']').toString();
    }
    
    public static String toString(float[] array) {
        if (array == null) {
            return "null";
        }
        int n = array.length - 1;
        if (n == -1) {
            return "[]";
        }
        StringBuilder sb = new StringBuilder();
        sb.append('[');
        int n2 = 0;
        while (true) {
            sb.append(array[n2]);
            if (n2 == n) {
                break;
            }
            sb.append(", ");
            ++n2;
        }
        return sb.append(']').toString();
    }
    
    public static String toString(double[] array) {
        if (array == null) {
            return "null";
        }
        int n = array.length - 1;
        if (n == -1) {
            return "[]";
        }
        StringBuilder sb = new StringBuilder();
        sb.append('[');
        int n2 = 0;
        while (true) {
            sb.append(array[n2]);
            if (n2 == n) {
                break;
            }
            sb.append(", ");
            ++n2;
        }
        return sb.append(']').toString();
    }
    
    public static String toString(Object[] array) {
        if (array == null) {
            return "null";
        }
        int n = array.length - 1;
        if (n == -1) {
            return "[]";
        }
        StringBuilder sb = new StringBuilder();
        sb.append('[');
        int n2 = 0;
        while (true) {
            sb.append(String.valueOf(array[n2]));
            if (n2 == n) {
                break;
            }
            sb.append(", ");
            ++n2;
        }
        return sb.append(']').toString();
    }
    
    public static String deepToString(Object[] array) {
        if (array == null) {
            return "null";
        }
        int capacity = 20 * array.length;
        if (array.length != 0 && capacity <= 0) {
            capacity = Integer.MAX_VALUE;
        }
        StringBuilder o = new StringBuilder(capacity);
        deepToString(array, o, new HashSet());
        return o.toString();
    }
    
    private static void deepToString(Object[] array, StringBuilder sb, Set<Object[]> set) {
        if (array == null) {
            sb.append("null");
            return;
        }
        int n = array.length - 1;
        if (n == -1) {
            sb.append("[]");
            return;
        }
        set.add(array);
        sb.append('[');
        int n2 = 0;
        while (true) {
            Object o = array[n2];
            if (o == null) {
                sb.append("null");
            }
            else {
                Class<Object> class1 = o.getClass();
                if (class1.isArray()) {
                    if (class1 == byte[].class) {
                        sb.append(toString((byte[])(byte[])o));
                    }
                    else if (class1 == short[].class) {
                        sb.append(toString((short[])(short[])o));
                    }
                    else if (class1 == int[].class) {
                        sb.append(toString((int[])(int[])o));
                    }
                    else if (class1 == long[].class) {
                        sb.append(toString((long[])(long[])o));
                    }
                    else if (class1 == char[].class) {
                        sb.append(toString((char[])(char[])o));
                    }
                    else if (class1 == float[].class) {
                        sb.append(toString((float[])(float[])o));
                    }
                    else if (class1 == double[].class) {
                        sb.append(toString((double[])(double[])o));
                    }
                    else if (class1 == boolean[].class) {
                        sb.append(toString((boolean[])(boolean[])o));
                    }
                    else if (set.contains(o)) {
                        sb.append("[...]");
                    }
                    else {
                        deepToString((Object[])(Object[])o, sb, set);
                    }
                }
                else {
                    sb.append(o.toString());
                }
            }
            if (n2 == n) {
                break;
            }
            sb.append(", ");
            ++n2;
        }
        sb.append(']');
        set.remove(array);
        return;
    }
    
    public static <T> void setAll(T[] array, IntFunction<? extends T> intFunction) {
        Objects.requireNonNull(intFunction);
        for (int i = 0; i < array.length; ++i) {
            array[i] = intFunction.apply(i);
        }
    }
    
    public static <T> void parallelSetAll(T[] array, IntFunction<? extends T> intFunction) {
        Objects.requireNonNull(intFunction);
        IntStream.range(0, array.length).parallel().forEach(n2/* int, */ -> p0[n2] = p1.apply(n2));
    }
    
    public static void setAll(int[] array, IntUnaryOperator intUnaryOperator) {
        Objects.requireNonNull(intUnaryOperator);
        for (int i = 0; i < array.length; ++i) {
            array[i] = intUnaryOperator.applyAsInt(i);
        }
    }
    
    public static void parallelSetAll(int[] array, IntUnaryOperator intUnaryOperator) {
        Objects.requireNonNull(intUnaryOperator);
        IntStream.range(0, array.length).parallel().forEach(n2/* int, */ -> p0[n2] = p1.applyAsInt(n2));
    }
    
    public static void setAll(long[] array, IntToLongFunction intToLongFunction) {
        Objects.requireNonNull(intToLongFunction);
        for (int i = 0; i < array.length; ++i) {
            array[i] = intToLongFunction.applyAsLong(i);
        }
    }
    
    public static void parallelSetAll(long[] array, IntToLongFunction intToLongFunction) {
        Objects.requireNonNull(intToLongFunction);
        IntStream.range(0, array.length).parallel().forEach(n2/* int, */ -> p0[n2] = p1.applyAsLong(n2));
    }
    
    public static void setAll(double[] array, IntToDoubleFunction intToDoubleFunction) {
        Objects.requireNonNull(intToDoubleFunction);
        for (int i = 0; i < array.length; ++i) {
            array[i] = intToDoubleFunction.applyAsDouble(i);
        }
    }
    
    public static void parallelSetAll(double[] array, IntToDoubleFunction intToDoubleFunction) {
        Objects.requireNonNull(intToDoubleFunction);
        IntStream.range(0, array.length).parallel().forEach(n2/* int, */ -> p0[n2] = p1.applyAsDouble(n2));
    }
    
    public static <T> Spliterator<T> spliterator(T[] array) {
        return Spliterators.spliterator(array, 1040);
    }
    
    public static <T> Spliterator<T> spliterator(T[] array, int n, int n2) {
        return Spliterators.spliterator(array, n, n2, 1040);
    }
    
    public static Spliterator.OfInt spliterator(int[] array) {
        return Spliterators.spliterator(array, 1040);
    }
    
    public static Spliterator.OfInt spliterator(int[] array, int n, int n2) {
        return Spliterators.spliterator(array, n, n2, 1040);
    }
    
    public static Spliterator.OfLong spliterator(long[] array) {
        return Spliterators.spliterator(array, 1040);
    }
    
    public static Spliterator.OfLong spliterator(long[] array, int n, int n2) {
        return Spliterators.spliterator(array, n, n2, 1040);
    }
    
    public static Spliterator.OfDouble spliterator(double[] array) {
        return Spliterators.spliterator(array, 1040);
    }
    
    public static Spliterator.OfDouble spliterator(double[] array, int n, int n2) {
        return Spliterators.spliterator(array, n, n2, 1040);
    }
    
    public static <T> Stream<T> stream(T[] array) {
        return stream(array, 0, array.length);
    }
    
    public static <T> Stream<T> stream(T[] array, int n, int n2) {
        return StreamSupport.stream(spliterator(array, n, n2), false);
    }
    
    public static IntStream stream(int[] array) {
        return stream(array, 0, array.length);
    }
    
    public static IntStream stream(int[] array, int n, int n2) {
        return StreamSupport.intStream(spliterator(array, n, n2), false);
    }
    
    public static LongStream stream(long[] array) {
        return stream(array, 0, array.length);
    }
    
    public static LongStream stream(long[] array, int n, int n2) {
        return StreamSupport.longStream(spliterator(array, n, n2), false);
    }
    
    public static DoubleStream stream(double[] array) {
        return stream(array, 0, array.length);
    }
    
    public static DoubleStream stream(double[] array, int n, int n2) {
        return StreamSupport.doubleStream(spliterator(array, n, n2), false);
    }
    
    static final class NaturalOrder implements Comparator<Object>
    {
        static final Arrays.NaturalOrder INSTANCE;
        
        @Override
        public int compare(Object o, Object o2) {
            return ((Comparable)o).compareTo(o2);
        }
        
        static {
            INSTANCE = new Arrays.NaturalOrder();
        }
    }
    
    static final class LegacyMergeSort
    {
        private static final boolean userRequested;
        
        static {
            userRequested = (boolean)AccessController.doPrivileged(new GetBooleanAction("java.util.Arrays.useLegacyMergeSort"));
        }
    }
    
    private static class ArrayList<E> extends AbstractList<E> implements RandomAccess, Serializable
    {
        private static final long serialVersionUID = -2764017481108945198L;
        private final E[] a;
        
        ArrayList(E[] array) {
            this.a = (E[])Objects.requireNonNull(array);
        }
        
        @Override
        public int size() {
            return this.a.length;
        }
        
        @Override
        public Object[] toArray() {
            return (E[])this.a.clone();
        }
        
        @Override
        public <T> T[] toArray(T[] array) {
            int size = this.size();
            if (array.length < size) {
                return Arrays.copyOf(this.a, size, array.getClass());
            }
            System.arraycopy(this.a, 0, array, 0, size);
            if (array.length > size) {
                array[size] = null;
                return array;
            }
            return array;
        }
        
        @Override
        public E get(int n) {
            return this.a[n];
        }
        
        @Override
        public E set(int n, E e) {
            Object o = this.a[n];
            this.a[n] = e;
            return o;
        }
        
        @Override
        public int indexOf(Object o) {
            Object[] a = this.a;
            if (o == null) {
                int j = 0;
                while (j < a.length) {
                    if (a[j] == null) {
                        return j;
                    }
                    ++j;
                }
            }
            else {
                int i = 0;
                while (i < a.length) {
                    if (o.equals(a[i])) {
                        return i;
                    }
                    ++i;
                }
            }
            return -1;
        }
        
        @Override
        public boolean contains(Object o) {
            return this.indexOf(o) != -1;
        }
        
        @Override
        public Spliterator<E> spliterator() {
            return Spliterators.spliterator(this.a, 16);
        }
        
        @Override
        public void forEach(Consumer<? super E> consumer) {
            Objects.requireNonNull(consumer);
            Object[] a = this.a;
            for (int length = a.length, i = 0; i < length; ++i) {
                consumer.accept(a[i]);
            }
        }
        
        @Override
        public void replaceAll(UnaryOperator<E> unaryOperator) {
            Objects.requireNonNull(unaryOperator);
            Object[] a = this.a;
            for (int i = 0; i < a.length; ++i) {
                a[i] = unaryOperator.apply(a[i]);
            }
        }
        
        @Override
        public void sort(Comparator<? super E> comparator) {
            Arrays.sort(this.a, comparator);
        }
    }
}
